    001/*
    002    Licensed to the Apache Software Foundation (ASF) under one
    003    or more contributor license agreements.  See the NOTICE file
    004    distributed with this work for additional information
    005    regarding copyright ownership.  The ASF licenses this file
    006    to you under the Apache License, Version 2.0 (the
    007    "License"); you may not use this file except in compliance
    008    with the License.  You may obtain a copy of the License at
    009
    010       http://www.apache.org/licenses/LICENSE-2.0
    011
    012    Unless required by applicable law or agreed to in writing,
    013    software distributed under the License is distributed on an
    014    "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    015    KIND, either express or implied.  See the License for the
    016    specific language governing permissions and limitations
    017    under the License.
    018 */
    019package org.apache.wiki.render;
    020
    021import org.apache.wiki.api.core.Context;
    022import org.apache.wiki.parser.WikiDocument;
    023
    024import java.io.IOException;
    025
    026/**
    027 *  Provides an interface to the basic rendering engine. This class is an abstract class instead of an interface because
    028 *  it is expected that rendering capabilities are increased at some point, and I would hate if renderers broke.
    029 *  This class allows some sane defaults to be implemented.
    030 *
    031 *  @since  2.4
    032 */
    033public abstract class WikiRenderer {
    034
    035    protected final Context     m_context;
    036    protected final WikiDocument    m_document;
    037
    038    public static final String LINKS_TRANSLATION = "$1#$2";
    039    public static final String LINKS_SOURCE = "(.+)#section-.+-(.+)";
    040
    041    /**
    042     *  Create a WikiRenderer.
    043     *
    044     *  @param context A WikiContext in which the rendering will take place.
    045     *  @param doc The WikiDocument which shall be rendered.
    046     */
    047    protected WikiRenderer( final Context context, final WikiDocument doc ) {
    048        m_context = context;
    049        m_document = doc;
    050        doc.setContext( context ); // Make sure it is set
    051    }
    052
    053    /**
    054     *  Renders and returns the end result.
    055     *
    056     *  @return A rendered string.
    057     *  @throws IOException If rendering fails.
    058     */
    059    public abstract String getString()
    060        throws IOException;
    061
    062}